package com.gzlh.controller;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.XmlUtil;
import cn.hutool.extra.spring.SpringUtil;
import com.gzlh.event.EventBus;
import com.gzlh.utils.FileUtils;
import com.gzlh.utils.RedisUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.io.*;
import java.net.Socket;
import java.net.URL;
import java.net.URLConnection;
import java.util.*;


@RestController
@RequestMapping("/test")
public class TestController {
    @Value("${file.root-path}")
    private String path;
    @Value("${application.channel-name}")
    private String channel;
    @Autowired
    private RedisUtil redisUtil;

    @PostMapping("/t")
    public void test(
            @RequestBody String xmlStr
//            HttpServletRequest request
    ) throws IOException {
//        String xmlStr = IOUtils.toString(request.getInputStream(), request.getCharacterEncoding());

        Map<String, Object> StringObjectMap = new HashMap<>();

        XmlUtil.xmlToMap(xmlStr, StringObjectMap);

        Map<String, Object> ic = BeanUtil.beanToMap(StringObjectMap.get("IC"));
        Map<String, Object> weight =BeanUtil.beanToMap(StringObjectMap.get("WEIGHT"));
        Map<String, Object> car = BeanUtil.beanToMap(StringObjectMap.get("CAR"));
        Map<String, Object> conta =BeanUtil.beanToMap(StringObjectMap.get("CONTA"));
        Map<String, Object> seal = BeanUtil.beanToMap(StringObjectMap.get("SEAL"));


        Map<String, String> cacheMap = new HashMap<>();
        cacheMap.put("carEcNo", (String) car.get("CAR_EC_NO"));
        cacheMap.put("contaIdF", !StringUtils.isEmpty((String) car.get("CONTA_ID_F"))?(String) car.get("CONTA_ID_F"):"");
        cacheMap.put("contaIdB", !StringUtils.isEmpty((String) car.get("CONTA_ID_B"))?(String) car.get("CONTA_ID_B"):"");
        redisUtil.set(channel,cacheMap);
//        System.out.println(redisUtil.hasKey(channel));

        Calendar calendar = Calendar.getInstance();
        String savePath=path+"/"+ calendar.get(Calendar.YEAR)+"-" + (calendar.get(Calendar.MONTH)+1);

        Map<String, String> picMap = new HashMap<>();
        for (Map.Entry<String, Object> entry : conta.entrySet()) {
            if(entry.getKey().contains("PIC")&& !StringUtils.isEmpty((String) entry.getValue())){
                String filePath = FileUtils.downLoad((String) entry.getValue(),savePath);
                String base64 = FileUtils.getBase64FromImg(filePath);
                picMap.put(entry.getKey(),base64);
            }
        }

        EventBus eventBus = SpringUtil.getBean(EventBus.class);
        eventBus.start("WEIGHBRIDGE.READ");

    }


}
